/* cmplxm_c subroutine
 * complex multiplication computation
 * IRCOM GROUP - Author : A.Layec
 */
 
/* REVISION HISTORY :
 * $Log$
 */
 
#include "mod_num_lib.h"

/*
 * cmplxm_c routine de calcul de multiplication de vecteurs complexes
 *
 * n           : la taille des vecteurs
 * [z1_r;z1_i] : adresses de dpart du vecteur complexe 1
 * [z2_r;z2_i] : adresses de dpart du vecteur complexe 2
 * [y_r;y_i]   : adresses de dpart du vecteur complexe rsultat
 *
 * rmq : doit exister en version BLAS(!?)
 */
 
void cmplxm_c(int *n,double *z1_r,double *z1_i,double *z2_r,double *z2_i,double *y_r,double *y_i)
{
 /*dclaration des variables*/
 int i,l,n1,m;

 /*ralise multiplication complex*/ 
 /*F2C(wmmul)(&z1_r[0],&z1_i[0],(n1=1,&n1),&z2_r[0],&z2_i[0],(m=1,&m),&y_r[0],&y_i[0],(m=1,&m),n,(m=1,&m),n);*/
 for(i=0;i<(*n);i++)
 {
  y_r[i]=z1_r[i]*z2_r[i]-z1_i[i]*z2_i[i];
  y_i[i]=z1_r[i]*z2_i[i]+z1_i[i]*z2_r[i];
 }
  
 return;
}
