/* cpf_c subroutine
 * Ideal discrete D Flip-Flop
 * Phase/Frequency Detector
 * IRCOM GROUP - Author : A.Layec
 */
 
/* REVISION HISTORY :
 * $Log$
 */
 
#include "mod_num_lib.h"

/* cpf_c routine de calcul d'un comparateur phase frquence trois tats idal
 *
 * Entres :
 * n   : taille des vecteurs
 * nev : entre d'activation des horloges des bascules 
 *      1: bascule 1
 *      2: bascule 2
 *      3: bascule 1&2 (rmq : non programm)
 *      4: entre RAZ des deux bascules
 *
 * Sorties :
 * y1 : etat de sortie bascule 1 
 * y2 : etat de sortie bascule 2
 * Entres/sorties :
 * z1 : tat de sortie prcdent bascule 1
 * z2 : etat de sortie prcdent bascule 2
 */
 
void cpf_c(int *n,int *nev,double *z1,double *z2,double *y1,double *y2)
{
 /*dclaration*/
 int i;
 
 for (i=0;i<(*n);i++)
 {
  switch (nev[i])
   {
    case 1 :
    {
     if ((z1[i]==0) && (z2[i]==0)) {y1[i] = 1; y2[i] = 0;}
     else if (z1[i] == 1) {y1[i] = 1; y2[i] = 0;}
     else if (z2[i] == 1) {y1[i] = 0; y2[i] = 0;}
     else {y1[i] = 1; y2[i] = 0;}
     break;
    }

    case 2 :
    {
     if ((z1[i] == 0) && (z2[i] == 0)) {y1[i] = 0; y2[i] = 1;}
     else if (z1[i] == 1) {y1[i] = 0; y2[i] = 0;}
     else if (z2[i] == 1) {y1[i] = 0; y2[i] = 1;}
     else {y1[i] = 0; y2[i] = 1;}
     break;
    }
    
    case 4 :
    {
     y1[i]=0;
     y2[i]=0;
     break;
    }
    
    y1[i] = 0 ;
    y2[i] = 0;
    break;
   }
  /*Met en mmoire les tats*/ 
  z1[i]=y1[i];
  z2[i]=y2[i];
 }
 return;
}
