/* genint_c subroutine
 * Random Integer Number Generator
 * IRCOM GROUP - Author : A.Layec
 */
 
/* REVISION HISTORY :
 * $Log$
 */
 
#include "mod_num_lib.h"

/* genint_c routine de calcul de mots entiers alatoires
 * Entres :
 * n   : taille du  vecteur de sortie (scalaire)
 * m   : longueur des mots binaires des lments du vecteur de sorties (scalaire)
 * typ : type des gnrateurs binaires (scalaire)
 * (typ=0: gnre 1 seul bit cod NRZ
 *    =1: gnre 1 seul bit cod RZ, ou un mot non sign
 *    =2: gnre un mot cod code complment  2)
 * Sorties :
 * y : vecteur de sortie
 *
 * dpendances
 * math.h
 */

void genint_c(int *n,int *m,int *typ,double *y)
{
 /*dclaration des variables compteurs*/
 int k,i,j;
 
 for(i=0;i<(*n);i++)
 {
  switch (*typ)
  {
   /*Type 0 -> ddi signal NRZ*/
   case 0:
   {
    y[i]=(int)((rand()&1)*2-1);
    break;
   }
   /*Type 1 -> mot non sign*/
   case 1 :
   {
    k=1;
    k=k<<(*m);
    j=rand();
    y[i]=(j&(k-1));
    break;
   }
   /*Type 2 -> mot cod code complmnt  2*/
   case 2 :
   {
    j=rand();
    j -= 2<<((*m)-2);
    j &= (2<<((*m)-1)) - 1;
    j -= 2<<((*m)-2);
    y[i]=j;
    break;
   }
   break;
  }
 }
 return;
}
