/* modpsk_c subroutine
 * Phase Shift Keying Modulator
 * IRCOM GROUP - Author : A.Layec
 */
 
/* REVISION HISTORY :
 * $Log$
 */
 
#include "mod_num_lib.h"

/* modpsk_c routine de calcul des composantes I et Q en fonction
 * d'un numro symbole cod par tats de phase (psk)
 *
 * Entres :
 * n   : longueur des vecteurs (scalaire)
 * m   : nombre d'tat Attention - ici scalaire
 * u   : numro symbole (vecteur d'entre)
 * Sorties :
 * i_c : valeur de la composante i (vecteur de sortie 1)
 * q_c : valeur de la composante q (vecteur de sortie 2)
 * 
 * Dpendances :
 * math.h
 */
 
void modpsk_c(int *n,int *m,double *u,double *i_c, double *q_c)
{
 /*Dclaration des variables compteurs*/
 int k,i;
 
 for(i=0;i<(*n);i++)
 {
  /*rcupration de la valeur du port d'entre*/
  k=(int)u[i];
  /*Calcul des composantes i et q*/
  i_c[i]=cos(M_PI*(2*k+1)/(*m));
  q_c[i]=-sin(M_PI*(2*k+1)/(*m));
 }
 return;
}
