/* surecht_c subroutine
 * Up-Sampling Computation
 * IRCOM GROUP - Author : A.Layec
 */
 
/* REVISION HISTORY :
 * $Log$
 */
 
#include "mod_num_lib.h"

/* surecht_c routine de calcul de sur-chantillonnage en temporel
 *
 * Entres :
 * opt    : option 0: sur-chantillonnage classique
 *                 1: sur-chantillonnage avec insertion de zros(Dirac)
 * n      : taille du vecteur original
 * nech   : facteur de sur-chantillonnage
 * init_c : adresse du compteur
 * u      : adresse du vecteur d'entre (de taille n)
 * Sorties :
 * y      : adresse du vecteur de sortie (de taille n*nech)
 *
 */
 
void surecht_c(int *opt,int *n,int *nech,int *init_c,double *u,double *y)
{
 /*dclaration des variables compteur*/
 int i,j;
 int counter;
 
 switch(*opt)
 {
  /*Surchantillonnage classique*/
  case 0 : {
            for(j=0;j<(*n);j++)
            {
             for(i=0;i<(*nech);i++) y[j*(*nech)+i]=u[j];
            }
            break;
           }

  /*Surchantillonnage avec insertion zro*/
  case 1 : {
            counter=(*init_c);
            i=0;
            for(j=0;j<(*n)*(*nech);j++)
            {
             y[j]=0;
             if(j==counter)
             {
              counter=counter+(*nech);
              y[j]=u[i];
              i++;
             }
            }
            break;
           }
  /*other case*/
  break;
 }
 return;
}
