/* cpft Scicos Phase/Frequency Comparator block including 
 * delay element for the RAZ of flip-flop
 * Type 4 simulation function ver 1.0 - scilab-3.0
 * 13 janvier 2004 - IRCOM GROUP - Author : A.Layec
 */
 
 /* REVISION HISTORY :
 * $Log$
 */
 
#include "scicos_block.h"
#include <stdio.h>

/* entres rgulires      : nant
 * sorties : y1[0..ny-1]   : vecteur de sortie UP
 *           y2[0..ny-1]   : vecteur de sortie DOWN
 * entres vnementielles : nev = 1 : entre d'horloge de mise  jour du cpf
 *                           nev = 2 : entre d'horloge du diviseur de retour
 *                           nev = 4 : entre d'horloge de RAZ
 * sortie vnementielles  : evout[0] : vnement de remise  zro
 * paramtres entiers : outsz[0] : taille des vecteurs UP et DOWN (ny)
 *                      
 * paramtres rels   : rpar[0..ny-1] : retard des Remises A Zro
 * Etats discrets     : z[0],z[ny]    : etats mmoires des bascules
 *                      z[2*ny] : etat du comparateur (0:activ,1:dsactiv)
 */
 
void cpft(scicos_block *block,int flag)
{
 /*dclaration*/
 int nev;
 int ny;
 double *y1, *y2;
 double *delay;
 
 /*rcupration des adresses*/
 y1=(double *)block->outptr[0];
 y2=(double *)block->outptr[1];
 nev=block->nevprt;
 
 /*rcupration des paramtres*/
 ny=block->outsz[0];
 delay=&block->rpar[0];
 
 /*Appel cpft*/
 cpft_c(&ny,&nev,&flag,&delay[0],&block->z[0],&block->z[ny],&block->evout[0],&y1[0],&y2[0],&block->z[2*ny]);
}
