/* fmoduloc Scicos float moduloc function
 * Type 2 simulation function ver 1.0 - scilab-2.6&2.7&3.0
 * 19 octobre 2003 - IRCOM GROUP - Author : A.Layec
 */
 
/* REVISION HISTORY :
 * $Log$
 */
 
#include "machine.h"

/* Cette fonction de simulation ralise la fonction non-lineaire
 *  modulo sur des nombres dfinis en virgule flottante.
 * y=u-m*(int)(u/m)
 * entres rgulires : vecteur des entres u[0..nu-1]
 * sorties rgulires : vecteur des sorties y[nu..2nu-1]
 * paramtres : rpar[0..nu-1] : m : vecteur des amplitudes
 * entres d'venement : nant
 * sorties d'venement : nant
 *
 * la sortie est tjs ngative lorsque l'entre est ngative
 * la sortie est tjs positive lorsque l'entre est positive
 */
 
/*prototype*/
void fmoduloc(flag,nevprt,t,xd,x,nx,z,nz,tvec,ntvec,rpar,nrpar,
              ipar,nipar,inptr,insz,nin,outptr,outsz,nout)
integer *flag,*nevprt,*nx,*nz,*ntvec,*nrpar,ipar[],*nipar,insz[],*nin,outsz[],*nout;
double x[],xd[],z[],tvec[],rpar[];
double *inptr[],*outptr[],*t;
{
 /*dclaration des variables*/
 int nu,i;
 double *y;
 double *u;

 /*Rcupration des adresses des ports rguliers*/
 y=(double *)outptr[0];
 u=(double *)inptr[0];

 /*rcupration de la taille du port d'entre rgulier*/
 nu=insz[0];

 /*Calcul de la valeur modulo et place la dans le registre y[]*/
 for(i=0;i<nu;i++) y[i] = u[i]-rpar[0]*(int)(u[i]/rpar[0]);
}
