/* Genmllsrs Scicos Maximal Length Linear feddback Shift Regiter Sequences Generator block
 * Type 4 simulation function ver 1.1 - scilab-3.0
 * 15 dcembre 2004 - IRCOM GROUP - Author : A.Layec
 */
 
/* REVISION HISTORY :
 * $Log$
 */
 
#include "machine.h"
#include <stdio.h>
#include "scicos_block.h"

/* Cette fonction de simulation est un gnrateur de sequences pseudoalatoires
 *  longueur maximale.
 * Les valeurs de sortie sont soit -1 soit 1 et dependent d'une combinaison linaire
 * des valeurs des registres internes Z. Les oprations sont ralises grce  des
 * oprateurs de manipulations de bit, et les mots binaires sont stocks par leurs valeurs entires.
 * La fonction est capable de dlivrer des vecteurs de nb_gen gnrateurs.
 *
 * Entre rgulire : nant
 * Sorties rgulires : y[0..ny[0]-1]                              : sortie du gnrateur 1
 *                      y[ny[0]..ny[0]+ny[1]-1]                    : sortie du gnrateur 2
 *                      ...
 *                      y[ny[nb_gen-2]..ny[nb_gen-2]+ny[nb_gen-1]] : sortie du gnrateur nb_gen
 * 
 * Entre venementielle : priode de dclenchement
 * Sortie vnementielle : nant.
 *
 * Etats discrets : z[0..nb_gen-1]        : valeur des registres  dcalage 
 *             
 * paramtres entiers : ipar[0]                    : nb_gen nombre de gnrateurs
 *                      ipar[1..nb_gen]            : ny[0..nb_gen-1] longeur des vecteurs de sortie des gn
 *                      ipar[nb_gen+1..2*nb_gen]   : longueur des registres (nbre de bascules)
 *                     ipar[2*nb_gen+1..3*nb_gen] : valeurs des coefficients des registres
 */

void genmllsrs(scicos_block *block,int flag)
{
  /*dclaration des variables*/
  int ny;
  int nb_gen;
  int coef;
  int reg,N;
  int i,j,k,l;
  int y_ptr;
  double *y;

  /*Rcupration des adresses des ports rguliers*/
  y=(double *)block->outptr[0];

  /*Rcupration du nombre de gnrateurs*/
  nb_gen=block->ipar[0];
  
  /*Seulement sur flag 1*/
  if(flag==1)
  {
   for(k=0;k<nb_gen;k++)
   {
    /*Dfinition de l'adresse de dpart de la sortie du gn k*/
    if(k!=0) y_ptr=y_ptr+block->ipar[k];
    else y_ptr=0;
    
    /*Rcupration de la longueur du vecteur de sortie*/
    ny=block->ipar[1+k];
    
    /*Rcupration de la longueur du registre*/
    N=block->ipar[nb_gen+1+k];

    /*Rcupration de la valeur du registre*/
    reg=(int) block->z[k];
    
    /*Rcupration de la valeur des coef*/
    coef=block->ipar[2*nb_gen+1+k];
    
     /*Appel routine mllsrs_c*/   
    mllsrs_c(&N,&ny,&y[y_ptr],&reg,&coef);

    /*Sauvegarde la valeur du registre dans z[0]*/
    block->z[k] = reg;
   }
  }
}
