/* int_euler Scicos discrete integral by euler method block 
 * Type 2 simulation function ver 1.0 - scilab-2.6&2.7
 * 17 novembre 2003 - IRCOM GROUP - Author : A.Layec
 */
 
/* REVISION HISTORY :
 * $Log$
 */
 
#include "machine.h"

/* Cette fonction de simulation ralise une intgration discrte
 * du vecteur d'entre par la mthode d'Euler arrire (drive  gauche) :
 * y[k]=h*u[k]+y[k-1]
 * o h est le pas d'intgration, y[k] le vecteur de sortie,
 * et u[k] le vecteur d'entre
 *
 * entre rgulires : u[0..nu-1] vecteur d'entre
 * sorties rgulires : y[0..nu-1] registre de sortie
 * entre vnementielle : Instants de dclenchement
 * sortie vnementielle : nant.
 * tat discret : z[0..nu-1] vecteur des tats de sortie discrets prcdents
 *
 * paramtre rel : rpar[0] pas d'intgration
 */
 
/*prototype*/
void int_euler(flag,nevprt,t,xd,x,nx,z,nz,tvec,ntvec,rpar,nrpar,
               ipar,nipar,inptr,insz,nin,outptr,outsz,nout)
integer *flag,*nevprt,*nx,*nz,*ntvec,*nrpar,ipar[],*nipar,insz[],*nin,outsz[],*nout;
double x[],xd[],z[],tvec[],rpar[];
double *inptr[],*outptr[],*t;
{
  /*dclaration des variables*/
  double *y;
  double *u;
  int i,nu;

  /*rcupration de l'adresses des ports rguliers*/
  y=(double *)outptr[0];
  u=(double *)inptr[0];

  /*Rcupration de la taille du port d'entre*/
  nu=insz[0];

  /*Le flag 1 calcule l'integrale et place le rsultat dans le registre y[]*/
  if(*flag==1)
    {
     for(i=0;i<nu;i++) y[i]=rpar[0]*u[i]+z[i];
    }

  /*le flag 2 place l'tat de sortie y dans z*/
  else if(*flag==2)
  {
   for(i=0;i<nu;i++) z[i]=y[i];
  }
}
