/* ref_noise Scicos Noisy reference block
 * Type 2 simulation - scilab-2.6&2.7&3.0
 * IRCOM GROUP - Author : A.Layec
 */
 
/* REVISION HISTORY :
 * $Log$
 */
 
#define Abs(x) ( ( (x) >= 0) ? (x) : -( x) )
#include "machine.h"
#include <math.h>
#include<stdlib.h>  /*pour RAND_MAX*/
#include <stdio.h>
#define M_PI		3.14159265358979323846
/* rpar[0]:sigma
 * rpar[1]:moyenne
 * rpar[2]:Tref
 */

/*prototype*/
void ref_noise(flag,nevprt,t,xd,x,nx,z,nz,tvec,ntvec,rpar,nrpar,
               ipar,nipar,inptr,insz,nin,outptr,outsz,nout)
integer *flag,*nevprt,*nx,*nz,*ntvec,*nrpar,ipar[],*nipar,insz[],*nin,outsz[],*nout;
double x[],xd[],z[],tvec[],rpar[];
double *inptr[],*outptr[],*t;
{
  /*dclaration des variables*/
  double *y;
  double rand1, rand2;
  double amplitude, phase;

  /*rcupration de l'adresses des ports rguliers*/
  y=(double *)outptr[0];

  /*Le flag 1 calcule le registre de sortie y*/
  if(*flag==1)
  {
    /*calcul rand1*/
    rand1=((double)(rand()%RAND_MAX))/((double)RAND_MAX);
    /*test rand1*/
    while((rand1<=0) || (rand1>=1)) rand1=((double)(rand()%RAND_MAX))/((double)RAND_MAX);

    /*calcul rand2*/
    rand2=((double)(rand()%RAND_MAX))/((double)RAND_MAX);
    /*test rand2*/
    while((rand2<=0) || (rand2>=1)) rand2=((double)(rand()%RAND_MAX))/((double)RAND_MAX);

    /*Calcul amplitude et phase*/
    amplitude=sqrt(-rpar[0]*log(rand1));
    phase=2*M_PI*rand2;

    /*Copie amplitude et phase dans y*/
    z[0]=rpar[1]+amplitude*cos(phase);

    while( (abs(z[0])>=rpar[2]))
    {
     /*calcul rand1*/
     rand1=((double)(rand()%RAND_MAX))/((double)RAND_MAX);
     /*test rand1*/
     while((rand1<=0) || (rand1>=1)) rand1=((double)(rand()%RAND_MAX))/((double)RAND_MAX);

     /*calcul rand2*/
     rand2=((double)(rand()%RAND_MAX))/((double)RAND_MAX);
     /*test rand2*/
     while((rand2<=0) || (rand2>=1)) rand2=((double)(rand()%RAND_MAX))/((double)RAND_MAX);

     /*Calcul amplitude et phase*/
     amplitude=sqrt(-rpar[0]*log(rand1));
     phase=2*M_PI*rand2;

     /*Copie amplitude et phase dans y*/
     z[0]=rpar[1]+amplitude*cos(phase);
    }

    /*fprintf(stderr,"*t=%f, z[0]=%f, z[1]=%f\n",*t,z[0],z[1]);*/
    y[0]=z[0];
   }

   /*Le flag 3 calcul les sorties vnementielles*/
   else if(*flag==3)
   {
    /*Calcul ref non bruit*/
    tvec[0]=*t+rpar[2];

    /*calcul ref bruit*/
    if(z[1]==0) /*si z[0]=1 alors calcul tvec[1]*/
    {
     z[1]=1;
     tvec[1]=*t+rpar[2]+z[0];
    }
    else /*sinon calcul tvec[2]*/
    {
     z[1]=0;
     tvec[2]=*t+rpar[2]+z[0];
    }
    /*fprintf(stderr,"tvec[0]=%f, tvec[1]=%f, tvec[2]=%f\n", tvec[0],tvec[1],tvec[2]);*/
   }
}
