/* teb2 Scicos block
 * Type 4 simulation function ver 1.0 - scilab-3.0
 * 9 Novembre 2004 - IRCOM GROUP - Author : A.Layec
 * 15 Fev 2005 : rajout option sur nbre d'vnement
 */
 
/* REVISION HISTORY :
 * $Log$
 */
 
#include <stdio.h>
#include "scicos_block.h"

/* Cette fonction de simulation ralise la comparaison
 * bit  bit de deux vecteurs d'entiers non sign.
 * Lorsque qu'un lment des vecteurs diffre, la fonction
 * cherche quel bit est faux et incrmente son tat discret pour
 * chaque bit faux(flag2), puis elle recopie l'tat discret 
 * sur la sortie(flag1)
 * 
 * Entre rgulire : inptr[0][0..Nu-1] : Vecteur d'entier 1
 *                    inptr[1][0..Nu-1] : Vecteur d'entier 2
 * Sortie rgulire : outptr[0][0] : Valeur du compteur d'erreur
 * Entre vnementielle :  la rigueur(hrit)
 * Sortie vnementielle : nant
 * 
 * Paramtres entier : insz[0] : taille des vecteurs d'entre
 *                     ipar[0] : Nombre de bits 
 *                     ipar[1] : Nombre d'venement avant comptage
 * tat discret      : z[0] : compteur nb d'erreur
 *                     z[1] : compteur evnement
 */

/*prototype*/
void teb2(scicos_block *block,int flag)
{
  /*dclaration des variables*/
  int a,b,c;
  int i,j;
  
  /*Le flag 1 recopie la valeur de z[0] dans outptr[0][0]*/
  if(flag == 1) 
  {
    block->outptr[0][0]=block->z[0];
    block->z[1]=block->z[1]+1;
  }
  
  /*Le flag 2 ralise la comparaison bit  bit*/
  else if(flag == 2) 
  { 
   /*fprintf(stderr,"z[1]=%d\n",(int)block->z[1]);*/
   if((int)block->z[1]>block->ipar[1])
   {
    for(i=0;i<block->insz[0];i++)
    {  
     a=(int)block->inptr[0][i];
     b=(int)block->inptr[1][i];
     /*fprintf(stderr,"a=%d, b=%d\n",a,b);*/
     c=a^b;
     if(c!=0) /*si diffrence entre les lments i*/
     {
      for(j=0;j<block->ipar[0];j++)
      {
       if((1<<j & c)==1<<j)  /*comparaison bit  bit*/
       { 
        /*fprintf(stderr,"bit %d faux\n",j);*/
        block->z[0]++; /*incrmente compteur*/
       }
      } 
     }
    } 
   }
  }
}
